//============================================================================
// Name        : crypto.cpp
// Author      : 
// Version     :
// Copyright   : Your copyright notice
// Description : Hello World in C++, Ansi-style
//============================================================================

#include <iostream>
#include <stdio.h>
#include <ctime>
#include <fstream>
#include <cstdlib>

using namespace std;

static string password = "";
static int count = 0;

int bruteForceEval(string pass) {
	if (pass == password) {
		return 1;
	} else {
		return 0;
	}
}

int hillClimberEval(string pass) {
	int common = 0;
	for (unsigned int i = 0; i < pass.length() && i < password.length(); i++) {
		if (pass[i] == password[i])
			common++;
	}
	return common;
}

void HillClimber() {
	string hcCrack = "";
	unsigned int maxLength = 1000;
	cout << "\nHill Climber found partial password string: ";
	for (unsigned int i = 0; i < maxLength; i++) {
		for (unsigned int j = 0; j < 128; j++) {
			char c = j;
			string append = hcCrack + c;
			unsigned int common = hillClimberEval(append);
			if (common == password.length()) {
				cout << "\nHill Climber Cracked!!! Your password is: " << append
						<< endl;
				return;
			} else if (common == i + 1) {
				hcCrack = append;
				cout << c <<"."<< flush;
				break;
			}
		}
	}
	return;
}

bool BruteForce(int length, string s) {
	if (bruteForceEval(s) == 1) {
		cout << "\nBrute Force Cracked!!! Your password is: " << s << endl;
		return true;
	}

	if (length == 0) {
		count++;
		if (count % 5000000 == 0) { //Display progress, print a dot per 5 million numbers
			cout << "." << flush;
		}
		//cout<< s<<endl;
		return false;
	}

	for (int i = 0; i < 10; i++) {    //0-9 for each digit
		char c = '0' + i;
		string appended = s + c;
		if (BruteForce(length - 1, appended))
			return true;
	}
	return false;
}

/**
 * algorithm: 0 - BruteForce, 1 - HillClimber
 */
void Crack(int algo) {
	static int length = 1;
	static string generated = "";
	if (algo == 0) {
		while (true) {
			if (BruteForce(length, generated)) {
				break;
			};
			length++;
		}
	} else {
		HillClimber();
	}
}

int main(int argc, char *argv[]) {
	if (argc < 3) {
		cout << "Example: ./crack [password.txt] [algorithm]\n [algorithm]: 0 - BruteForce, 1 - HillClimber\n";
		return -1;
	};

	time_t start, end;
	ifstream passwordfile(argv[1]); //read filename from the argument
	if (passwordfile.is_open()) {
		getline(passwordfile, password); //reading the password from password.txt
		passwordfile.close();
	}

	int algorithm = atoi(argv[2]);
	printf("Cracking password in %s with %s...\n", argv[1], algorithm==0?"BruteForce":"HillClimber" );
	cout<<flush;
	time(&start);

	Crack(algorithm);
	time(&end);
	double dif = difftime(end, start);
	printf("%.0lf seconds elapsed.\n", dif);

	return 0;
}
